Index: /trunk/XTIDE_Universal_BIOS/makefile
===================================================================
--- /trunk/XTIDE_Universal_BIOS/makefile	(revision 591)
+++ /trunk/XTIDE_Universal_BIOS/makefile	(revision 592)
@@ -41,4 +41,5 @@
 # USE_AT                      Use features supported on AT and later systems (not available on XT) #
 # USE_UNDOC_INTEL             Optimizations for Intel CPU:s - do NOT use on NEC V20/V30/Sony CPU:s #
+# CLD_NEEDED                  Only needed for compatibility with buggy software/BIOSes             #
 #                                                                                                  #
 # ** AT Builds only (when USE_AT is defined)                                                       #
@@ -103,5 +104,5 @@
 # Assembler preprocessor defines.                               #
 #################################################################
-DEFINES_COMMON = MODULE_STRINGS_COMPRESSED MODULE_HOTKEYS MODULE_8BIT_IDE MODULE_EBIOS MODULE_SERIAL MODULE_SERIAL_FLOPPY MODULE_POWER_MANAGEMENT RESERVE_DIAGNOSTIC_CYLINDER NO_ATAID_VALIDATION
+DEFINES_COMMON = MODULE_STRINGS_COMPRESSED MODULE_HOTKEYS MODULE_8BIT_IDE MODULE_EBIOS MODULE_SERIAL MODULE_SERIAL_FLOPPY MODULE_POWER_MANAGEMENT RESERVE_DIAGNOSTIC_CYLINDER NO_ATAID_VALIDATION CLD_NEEDED
 DEFINES_COMMON_LARGE = MODULE_BOOT_MENU MODULE_8BIT_IDE_ADVANCED MODULE_COMPATIBLE_TABLES
 
@@ -114,5 +115,5 @@
 DEFINES_AT_LARGE = $(DEFINES_AT) $(DEFINES_COMMON_LARGE)
 
-DEFINES_XT_TINY = MODULE_STRINGS_COMPRESSED MODULE_8BIT_IDE NO_ATAID_VALIDATION
+DEFINES_XT_TINY = MODULE_STRINGS_COMPRESSED MODULE_8BIT_IDE NO_ATAID_VALIDATION CLD_NEEDED
 DEFINES_386_8K = $(DEFINES_AT) USE_386 MODULE_ADVANCED_ATA
 
@@ -125,19 +126,19 @@
 ###################
 
-# Target size of the ROM, used in main.asm for number of 512B blocks and by checksum Perl script below
-BIOS_SIZE = 8192		# For BIOS header (use even multiplier!)
-ROMSIZE = $(BIOS_SIZE)	# Size of binary to build when building with make checksum
-BIOS_SIZE_LARGE = 12288
-ROMSIZE_LARGE = $(BIOS_SIZE_LARGE)
+# Target size of the BIOS, used in main.asm for number of 512B blocks (CNT_ROM_BLOCKS) and by checksum Perl script below ('make checksum').
+# Note! The size must be a multiple of 2 KB for compatibility reasons.
+BIOS_SIZE_TINY = 4096
+BIOS_SIZE_SMALL = 8192
+BIOS_SIZE_LARGE = 10240
 
 # Add -D in front of every preprocessor define declaration
-DEFS_XT = $(DEFINES_XT:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE)
-DEFS_XTPLUS = $(DEFINES_XTPLUS:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE)
-DEFS_AT = $(DEFINES_AT:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE)
+DEFS_XT = $(DEFINES_XT:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE_SMALL)
+DEFS_XTPLUS = $(DEFINES_XTPLUS:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE_SMALL)
+DEFS_AT = $(DEFINES_AT:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE_SMALL)
 DEFS_XT_LARGE = $(DEFINES_XT_LARGE:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE_LARGE)
 DEFS_XTPLUS_LARGE = $(DEFINES_XTPLUS_LARGE:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE_LARGE)
 DEFS_AT_LARGE = $(DEFINES_AT_LARGE:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE_LARGE)
-DEFS_XT_TINY = $(DEFINES_XT_TINY:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE)
-DEFS_386_8K = $(DEFINES_386_8K:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE)
+DEFS_XT_TINY = $(DEFINES_XT_TINY:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE_TINY)
+DEFS_386_8K = $(DEFINES_386_8K:%=-D%) -DBIOS_SIZE=$(BIOS_SIZE_SMALL)
 DEFS_ALL_FEATURES = $(DEFINES_ALL_FEATURES:%=-D%)
 
@@ -220,5 +221,5 @@
 strings: src\Strings.asm
 	@$(AS) src\Strings.asm $(ASFLAGS) $(DEFS_AT_LARGE) -DCHECK_FOR_UNUSED_ENTRYPOINTS -DMODULE_STRINGS_COMPRESSED_PRECOMPRESS -o build\Strings.bin -l build\StringsPrecompress.lst
-	@perl ..\tools\StringsCompress.pl < build\StringsPrecompress.lst > src\StringsCompressed.asm
+	@perl ..\Tools\StringsCompress.pl < build\StringsPrecompress.lst > src\StringsCompressed.asm
 	@echo StringsCompressed.asm updated!
 
@@ -228,12 +229,12 @@
 
 checksum: all
-	@perl ..\tools\checksum.pl $(TARGET)_tiny.bin $(ROMSIZE)
-	@perl ..\tools\checksum.pl $(TARGET)_xt.bin $(ROMSIZE)
-	@perl ..\tools\checksum.pl $(TARGET)_xtp.bin $(ROMSIZE)
-	@perl ..\tools\checksum.pl $(TARGET)_at.bin $(ROMSIZE)
-	@perl ..\tools\checksum.pl $(TARGET)_xtl.bin $(ROMSIZE_LARGE)
-	@perl ..\tools\checksum.pl $(TARGET)_xtpl.bin $(ROMSIZE_LARGE)
-	@perl ..\tools\checksum.pl $(TARGET)_atl.bin $(ROMSIZE_LARGE)
-	@perl ..\tools\checksum.pl $(TARGET)_386.bin $(ROMSIZE)
+	@perl ..\Tools\checksum.pl $(TARGET)_tiny.bin $(BIOS_SIZE_TINY)
+	@perl ..\Tools\checksum.pl $(TARGET)_xt.bin $(BIOS_SIZE_SMALL)
+	@perl ..\Tools\checksum.pl $(TARGET)_xtp.bin $(BIOS_SIZE_SMALL)
+	@perl ..\Tools\checksum.pl $(TARGET)_at.bin $(BIOS_SIZE_SMALL)
+	@perl ..\Tools\checksum.pl $(TARGET)_xtl.bin $(BIOS_SIZE_LARGE)
+	@perl ..\Tools\checksum.pl $(TARGET)_xtpl.bin $(BIOS_SIZE_LARGE)
+	@perl ..\Tools\checksum.pl $(TARGET)_atl.bin $(BIOS_SIZE_LARGE)
+	@perl ..\Tools\checksum.pl $(TARGET)_386.bin $(BIOS_SIZE_SMALL)
 
 unused:
@@ -241,21 +242,21 @@
 	@$(AS) "$(SRC_ASM)" $(ASFLAGS) $(DEFS_ALL_FEATURES) $(DEFS_XT) $(DEFS_XT_PLUS) $(DEFS_AT) $(DEFS_XT_LARGE) $(DEFS_XTPLUS_LARGE) $(DEFS_AT_LARGE) $(DEFS_XT_TINY) $(DEFS_386_8K) -o"$(TARGET)_unused.asm" -l"$(TARGET)_unused.lst"
 	@$(AS) "$(SRC_ASM)" $(ASFLAGS) $(DEFS_ALL_FEATURES) $(DEFS_XT) $(DEFS_XT_PLUS) $(DEFS_AT) $(DEFS_XT_LARGE) $(DEFS_XTPLUS_LARGE) $(DEFS_AT_LARGE) $(DEFS_XT_TINY) $(DEFS_386_8K) -o"$(TARGET)_unused.asm" -E -DCHECK_FOR_UNUSED_ENTRYPOINTS
-	@perl ..\tools\unused.pl $(TARGET)_unused.lst $(TARGET)_unused.asm
+	@perl ..\Tools\unused.pl $(TARGET)_unused.lst $(TARGET)_unused.asm
 	@echo "XT Small"
 	@$(AS) "$(SRC_ASM)" $(ASFLAGS) $(DEFS_XT) -o"$(TARGET)_unused_xt.asm" -l"$(TARGET)_unused_xt.lst"
 	@$(AS) "$(SRC_ASM)" $(ASFLAGS) $(DEFS_XT) -o"$(TARGET)_unused_xt.asm" -E -DCHECK_FOR_UNUSED_ENTRYPOINTS
-	@perl ..\tools\unused.pl $(TARGET)_unused_xt.lst $(TARGET)_unused_xt.asm
+	@perl ..\Tools\unused.pl $(TARGET)_unused_xt.lst $(TARGET)_unused_xt.asm
 	@echo "XT Large"
 	@$(AS) "$(SRC_ASM)" $(ASFLAGS) $(DEFS_XT_LARGE) -o"$(TARGET)_unused_xtl.asm" -l"$(TARGET)_unused_xtl.lst"
 	@$(AS) "$(SRC_ASM)" $(ASFLAGS) $(DEFS_XT_LARGE) -o"$(TARGET)_unused_xtl.asm" -E -DCHECK_FOR_UNUSED_ENTRYPOINTS
-	@perl ..\tools\unused.pl $(TARGET)_unused_xtl.lst $(TARGET)_unused_xtl.asm
+	@perl ..\Tools\unused.pl $(TARGET)_unused_xtl.lst $(TARGET)_unused_xtl.asm
 	@echo "AT Small"
 	@$(AS) "$(SRC_ASM)" $(ASFLAGS) $(DEFS_AT) -o"$(TARGET)_unused_at.asm" -l"$(TARGET)_unused_at.lst"
 	@$(AS) "$(SRC_ASM)" $(ASFLAGS) $(DEFS_AT) -o"$(TARGET)_unused_at.asm" -E -DCHECK_FOR_UNUSED_ENTRYPOINTS
-	@perl ..\tools\unused.pl $(TARGET)_unused_at.lst $(TARGET)_unused_at.asm
+	@perl ..\Tools\unused.pl $(TARGET)_unused_at.lst $(TARGET)_unused_at.asm
 	@echo "AT Large"
 	@$(AS) "$(SRC_ASM)" $(ASFLAGS) $(DEFS_AT_LARGE) -o"$(TARGET)_unused_atl.asm" -l"$(TARGET)_unused_atl.lst"
 	@$(AS) "$(SRC_ASM)" $(ASFLAGS) $(DEFS_AT_LARGE) -o"$(TARGET)_unused_atl.asm" -E -DCHECK_FOR_UNUSED_ENTRYPOINTS
-	@perl ..\tools\unused.pl $(TARGET)_unused_atl.lst $(TARGET)_unused_atl.asm
-
-
+	@perl ..\Tools\unused.pl $(TARGET)_unused_atl.lst $(TARGET)_unused_atl.asm
+
+
Index: /trunk/XTIDE_Universal_BIOS_Configurator_v2/Inc/Variables.inc
===================================================================
--- /trunk/XTIDE_Universal_BIOS_Configurator_v2/Inc/Variables.inc	(revision 591)
+++ /trunk/XTIDE_Universal_BIOS_Configurator_v2/Inc/Variables.inc	(revision 592)
@@ -34,5 +34,5 @@
 struc CFGVARS
 	.pMenupage			resb	2			; Offset to MENUPAGE to display
-	.wFlags				resb	2			; Program flags
+	.wFlags				resb	2			; Program flags - Only the low byte is used currently and code depend on this
 	.wImageSizeInWords	resb	2			; Size in words for loaded ROM or FILE
 	.wEepromSegment		resb	2			; Segment where EEPROM is located
@@ -44,5 +44,5 @@
 endstruc
 
-; Bit defines for CFGVARS.wFlags
+; Bit defines for CFGVARS.wFlags (changes here might require changes elsewhere)
 FLG_CFGVARS_FILELOADED	EQU		(1<<0)	; BIOS is loaded from file
 FLG_CFGVARS_ROMLOADED	EQU		(1<<1)	; BIOS is loaded from EEPROM
Index: /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/AutoConfigure.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/AutoConfigure.asm	(revision 591)
+++ /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/AutoConfigure.asm	(revision 592)
@@ -43,5 +43,5 @@
 	call	ResetIdevarsToDefaultValues
 	call	DetectIdePortsAndDevices
-	call	EnableInterruptsForPrimaryAndSecondaryControllers
+	call	EnableInterruptsForAllStandardControllers
 	call	StoreAndDisplayNumberOfControllers
 
@@ -55,4 +55,5 @@
 ;	Parameters:
 ;		DS:DI:	Ptr to ROMVARS
+;		ES:DI:	Ptr to ROMVARS
 ;	Returns:
 ;		Nothing
@@ -123,5 +124,5 @@
 
 ;--------------------------------------------------------------------
-; EnableInterruptsForPrimaryAndSecondaryControllers
+; EnableInterruptsForAllStandardControllers
 ;	Parameters:
 ;		DS:DI:	Ptr to ROMVARS
@@ -130,8 +131,8 @@
 ;		Nothing
 ;	Corrupts registers:
-;		AX, ES
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-EnableInterruptsForPrimaryAndSecondaryControllers:
+;		AX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+EnableInterruptsForAllStandardControllers:
 	jcxz	.NoControllersDetected
 	call	Buffers_IsXTbuildLoaded
@@ -148,4 +149,17 @@
 	inc		ax	; 15
 	cmp		WORD [di+IDEVARS.wBasePort], DEVICE_ATA_SECONDARY_PORT
+
+%if 0
+	je		SHORT .EnableIrqAL
+
+	; Defaults on the GSI Inc. Model 2C EIDE controller
+	mov		al, 11
+	cmp		WORD [di+IDEVARS.wBasePort], DEVICE_ATA_TERTIARY_PORT
+	je		SHORT .EnableIrqAL
+
+	dec		ax	; 10
+	cmp		WORD [di+IDEVARS.wBasePort], DEVICE_ATA_QUATERNARY_PORT
+%endif
+
 	jne		SHORT .DoNotEnableIRQ
 
@@ -153,4 +167,5 @@
 	mov		[di+IDEVARS.bIRQ], al
 .DoNotEnableIRQ:
+	add		di, IDEVARS_size
 	loop	.CheckNextController
 	pop		cx
Index: /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/BiosFile.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/BiosFile.asm	(revision 591)
+++ /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/BiosFile.asm	(revision 592)
@@ -44,11 +44,10 @@
 	call	FileIO_CloseUsingHandleFromBX
 	call	DisplayFileLoadedSuccessfully
-	jmp		SHORT .Return
+	pop		ds
+	ret
 
 .DisplayErrorMessage:
 	call	FileIO_CloseUsingHandleFromBX
 	call	DisplayFailedToLoadFile
-ALIGN JUMP_ALIGN
-.Return:
 	pop		ds
 	ret
@@ -117,5 +116,7 @@
 	pop		es
 	mov		di, g_cfgVars+CFGVARS.szOpenedFile
+%ifdef CLD_NEEDED
 	cld
+%endif
 	call	String_CopyDSSItoESDIandGetLengthToCX
 	clc
Index: /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Buffers.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Buffers.asm	(revision 591)
+++ /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Buffers.asm	(revision 592)
@@ -49,7 +49,7 @@
 ALIGN JUMP_ALIGN
 Buffers_IsXtideUniversalBiosLoaded:
-	test	WORD [cs:g_cfgVars+CFGVARS.wFlags], FLG_CFGVARS_FILELOADED | FLG_CFGVARS_ROMLOADED
+	test	BYTE [cs:g_cfgVars+CFGVARS.wFlags], FLG_CFGVARS_FILELOADED | FLG_CFGVARS_ROMLOADED
 	jnz		SHORT .FileOrBiosLoaded
-	or		cl, 1		; Clear ZF
+	test	sp, sp		; Clear ZF
 	ret
 
@@ -76,5 +76,7 @@
 	add		di, BYTE ROMVARS.rgbSign
 	mov		cx, XTIDE_SIGNATURE_LENGTH / 2
+%ifdef CLD_NEEDED
 	cld
+%endif
 	eSEG_STR repe, cs, cmpsw
 
@@ -91,11 +93,15 @@
 ;				Cleared if some other (AT, 386) build is loaded
 ;	Corrupts registers:
-;		DI, ES
+;		Nothing
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 Buffers_IsXTbuildLoaded:
 %strlen BUILD_TYPE_OFFSET	TITLE_STRING_START
+	push	es
+	push	di
 	call	Buffers_GetFileBufferToESDI
 	cmp		WORD [es:di+ROMVARS.szTitle+BUILD_TYPE_OFFSET+1], 'XT'	; +1 is for '('
+	pop		di
+	pop		es
 	ret
 %undef BUILD_TYPE_OFFSET
@@ -105,15 +111,15 @@
 ; Buffers_NewBiosWithSizeInDXCXandSourceInAXhasBeenLoadedForConfiguration
 ;	Parameters:
-;		AX:		EEPROM source (FLG_CFGVARS_FILELOADED or FLG_CFGVARS_ROMLOADED)
+;		AL:		EEPROM source (FLG_CFGVARS_FILELOADED or FLG_CFGVARS_ROMLOADED)
 ;		DX:CX:	EEPROM size in bytes
 ;	Returns:
 ;		Nothing
 ;	Corrupts registers:
-;		AX, CX, DX
+;		CX, DX
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
 Buffers_NewBiosWithSizeInDXCXandSourceInAXhasBeenLoadedForConfiguration:
-	and		WORD [cs:g_cfgVars+CFGVARS.wFlags], ~(FLG_CFGVARS_FILELOADED | FLG_CFGVARS_ROMLOADED | FLG_CFGVARS_UNSAVED)
-	or		WORD [cs:g_cfgVars+CFGVARS.wFlags], ax
+	and		BYTE [cs:g_cfgVars+CFGVARS.wFlags], ~(FLG_CFGVARS_FILELOADED | FLG_CFGVARS_ROMLOADED | FLG_CFGVARS_UNSAVED)
+	or		[cs:g_cfgVars+CFGVARS.wFlags], al
 	shr		dx, 1
 	rcr		cx, 1
@@ -135,10 +141,10 @@
 ALIGN JUMP_ALIGN
 Buffers_SetUnsavedChanges:
-	or		WORD [cs:g_cfgVars+CFGVARS.wFlags], FLG_CFGVARS_UNSAVED
+	or		BYTE [cs:g_cfgVars+CFGVARS.wFlags], FLG_CFGVARS_UNSAVED
 	ret
 
 ALIGN JUMP_ALIGN
 Buffers_ClearUnsavedChanges:
-	and		WORD [cs:g_cfgVars+CFGVARS.wFlags], ~FLG_CFGVARS_UNSAVED
+	and		BYTE [cs:g_cfgVars+CFGVARS.wFlags], ~FLG_CFGVARS_UNSAVED
 	ret
 
@@ -155,9 +161,10 @@
 ALIGN JUMP_ALIGN
 Buffers_SaveChangesIfFileLoaded:
-	mov		ax, [cs:g_cfgVars+CFGVARS.wFlags]
-	and		ax, BYTE (FLG_CFGVARS_FILELOADED | FLG_CFGVARS_UNSAVED)
-	cmp		ax, BYTE (FLG_CFGVARS_FILELOADED | FLG_CFGVARS_UNSAVED)
-	jne		SHORT .NothingToSave
-	call	Dialogs_DisplaySaveChangesDialog
+	mov		al, [cs:g_cfgVars+CFGVARS.wFlags]
+	and		al, FLG_CFGVARS_FILELOADED | FLG_CFGVARS_UNSAVED
+	jz		SHORT .NothingToSave
+	jpo		SHORT .NothingToSave
+	mov		bx, g_szDlgSaveChanges
+	call	Dialogs_DisplayYesNoResponseDialogWithTitleStringInBX
 	jnz		SHORT .NothingToSave
 	jmp		BiosFile_SaveUnsavedChanges
@@ -181,5 +188,9 @@
 
 	eMOVZX	di, [cs:g_cfgVars+CFGVARS.bEepromType]
-	mov		cx, [cs:di+g_rgwEepromTypeToSizeInWords]
+;%if g_rgwEepromTypeToSizeInWords = 0	; *FIXME* It really is but NASM won't accept this.
+	mov		cx, [cs:di]
+;%else
+;	mov		cx, [cs:di+g_rgwEepromTypeToSizeInWords]
+;%endif
 	sub		cx, [cs:g_cfgVars+CFGVARS.wImageSizeInWords]	; CX = WORDs to append
 	jbe		SHORT .NoNeedToAppendZeroes
@@ -187,8 +198,10 @@
 	call	Buffers_GetFileBufferToESDI
 	mov		ax, [cs:g_cfgVars+CFGVARS.wImageSizeInWords]
-	shl		ax, 1
+	eSHL_IM	ax, 1
 	add		di, ax			; ES:DI now point first unused image byte
 	xor		ax, ax
+%ifdef CLD_NEEDED
 	cld
+%endif
 	rep stosw
 ALIGN JUMP_ALIGN
@@ -214,4 +227,7 @@
 	call	Buffers_GetFileBufferToESDI
 	call	EEPROM_GetXtideUniversalBiosSizeFromESDItoDXCX
+%ifdef CLD_NEEDED
+	cld
+%endif
 
 ; Compatibility fix for 3Com 3C503 cards where the ASIC returns 8080h as the last two bytes of the ROM.
@@ -223,6 +239,5 @@
 	jne		SHORT .BiosSizeIsNot8K
 	; The BIOS size is 8K and therefore a potential candidate for a 3Com 3C503 card.
-	dec		cx
-	dec		cx
+	mov		cl, (8192 - 3) & 0FFh
 	mov		ah, 3
 ALIGN JUMP_ALIGN
@@ -230,10 +245,9 @@
 .SumNextByte:
 	add		al, [es:di]
-.NextChecksumByte:
 	inc		di
 	loop	.SumNextByte
+.NextChecksumByte:
 	neg		al
-	mov		[es:di], al
-	inc		cx
+	stosb
 	dec		ah
 	jnz		SHORT .NextChecksumByte
@@ -306,7 +320,7 @@
 
 ;--------------------------------------------------------------------
-; Buffers_GetFileBufferToESDI
 ; Buffers_GetFlashComparisonBufferToESDI
 ; Buffers_GetFileDialogItemBufferToESDI
+; Buffers_GetFileBufferToESDI
 ;	Parameters:
 ;		Nothing
@@ -320,11 +334,6 @@
 Buffers_GetFileDialogItemBufferToESDI:
 	call	Buffers_GetFileBufferToESDI
-	push	di
 	mov		di, es
-	add		di, 1000h		; Third 64k page
-	mov		es, di
-	pop		di
-	ret
-ALIGN JUMP_ALIGN
+	SKIP2B	f
 Buffers_GetFileBufferToESDI:
 	mov		di, cs
Index: /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Dialogs.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Dialogs.asm	(revision 591)
+++ /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Dialogs.asm	(revision 592)
@@ -41,5 +41,4 @@
 	mov		cx, DIALOG_INPUT_size
 	call	Memory_ReserveCXbytesFromStackToDSSI
-	call	InitializeDialogInputFromDSSI
 	mov		[si+DIALOG_INPUT.fszTitle], di
 	jmp		SHORT DisplayMessageDialogWithMessageInCSDXandDialogInputInDSSI
@@ -65,5 +64,4 @@
 	mov		cx, DIALOG_INPUT_size
 	call	Memory_ReserveCXbytesFromStackToDSSI
-	call	InitializeDialogInputFromDSSI
 	mov		WORD [si+DIALOG_INPUT.fszTitle], g_szNotificationDialog
 	jmp		SHORT DisplayMessageDialogWithMessageInCSDXandDialogInputInDSSI
@@ -123,7 +121,7 @@
 
 ;--------------------------------------------------------------------
-; Dialogs_DisplayQuitDialog
-; Dialogs_DisplaySaveChangesDialog
+; Dialogs_DisplayYesNoResponseDialogWithTitleStringInBX
 ;	Parameters:
+;		BX:		Offset to dialog title string
 ;		SS:BP:	Menu handle
 ;	Returns:
@@ -134,5 +132,5 @@
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
-Dialogs_DisplayQuitDialog:
+Dialogs_DisplayYesNoResponseDialogWithTitleStringInBX:
 	push	ds
 
@@ -140,21 +138,9 @@
 	call	Memory_ReserveCXbytesFromStackToDSSI
 	call	InitializeDialogInputFromDSSI
-	mov		WORD [si+DIALOG_INPUT.fszTitle], g_szDlgExitToDos
-	jmp		Dialogs_DisplayQuitAndSaveChangesDialogsSharedEnding
-
-
-ALIGN JUMP_ALIGN
-Dialogs_DisplaySaveChangesDialog:
-	push	ds
-
-	mov		cx, DIALOG_INPUT_size
-	call	Memory_ReserveCXbytesFromStackToDSSI
-	call	InitializeDialogInputFromDSSI
-	mov		WORD [si+DIALOG_INPUT.fszTitle], g_szDlgSaveChanges
-Dialogs_DisplayQuitAndSaveChangesDialogsSharedEnding:
+	mov		[si+DIALOG_INPUT.fszTitle], bx
 	mov		WORD [si+DIALOG_INPUT.fszItems], g_szMultichoiceBooleanFlag
 	CALL_MENU_LIBRARY GetSelectionToAXwithInputInDSSI
 	add		sp, BYTE DIALOG_INPUT_size
-	cmp		ax, BYTE 1		; 1 = YES
+	dec		ax				; -1 = NO, 0 = YES
 
 	pop		ds
Index: /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/EEPROM.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/EEPROM.asm	(revision 591)
+++ /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/EEPROM.asm	(revision 592)
@@ -50,5 +50,5 @@
 ;		DX:CX:	BIOS size in bytes
 ;	Corrupts registers:
-;		AX, BX, SI, DI
+;		BX, SI, DI
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
@@ -61,5 +61,4 @@
 	call	LoadBytesFromRomToRamBuffer
 
-	call	EEPROM_GetXtideUniversalBiosSizeFromESDItoDXCX
 	pop		es
 	ret
@@ -90,8 +89,8 @@
 ;		Nothing
 ;	Returns:
-;		CF:		Set if EEPROM was found
-;				Cleared if EEPROM not found
-;	Corrupts registers:
-;		AX, BX, CX, SI, DI
+;		CF:		Cleared if EEPROM was found
+;				Set if EEPROM not found
+;	Corrupts registers:
+;		BX, CX, SI
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
@@ -107,8 +106,8 @@
 ;		SI:		Offset to first byte to load
 ;	Returns:
-;		CF:		Set if EEPROM was found
-;				Cleared if EEPROM not found
-;	Corrupts registers:
-;		AX, BX, CX, SI
+;		CF:		Cleared if EEPROM was found
+;				Set if EEPROM not found
+;	Corrupts registers:
+;		BX, SI
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
@@ -119,5 +118,5 @@
 
 	call	EEPROM_FindXtideUniversalBiosROMtoESDI
-	jnc		SHORT .XtideUniversalBiosNotFound
+	jc		SHORT .XtideUniversalBiosNotFound
 	push	es
 	pop		ds											; DS:SI points to ROM
@@ -126,7 +125,8 @@
 	mov		di, si										; ES:DI points to RAM buffer
 
+%ifdef CLD_NEEDED
 	cld
-	call	Memory_CopyCXbytesFromDSSItoESDI
-	stc
+%endif
+	call	Memory_CopyCXbytesFromDSSItoESDI			; Clears CF
 
 .XtideUniversalBiosNotFound:
@@ -143,8 +143,8 @@
 ;	Returns:
 ;		ES:DI:	EEPROM segment
-;		CF:		Set if EEPROM was found
-;				Cleared if EEPROM not found
-;	Corrupts registers:
-;		AX, BX
+;		CF:		Cleared if EEPROM was found
+;				Set if EEPROM not found
+;	Corrupts registers:
+;		BX
 ;--------------------------------------------------------------------
 ALIGN JUMP_ALIGN
@@ -159,13 +159,8 @@
 	mov		es, bx					; Possible ROM segment to ES
 	call	Buffers_IsXtideUniversalBiosSignatureInESDI
-	je		SHORT .RomFound
+	je		SHORT .RomFound			; If equal, CF=0
 	add		bx, 80h					; Increment by 2kB (minimum possible distance from the beginning of one option ROM to the next)
 	jnc		SHORT .SegmentLoop		; Loop until segment overflows
-	clc
-	jmp		SHORT .ReturnWithoutUpdatingCF
-ALIGN JUMP_ALIGN
 .RomFound:
-	stc
-.ReturnWithoutUpdatingCF:
 	pop		cx
 	pop		si
@@ -191,6 +186,12 @@
 	call	Buffers_GetFlashComparisonBufferToESDI
 	eMOVZX	bx, [cs:g_cfgVars+CFGVARS.bEepromType]
-	mov		cx, [cs:bx+g_rgwEepromTypeToSizeInWords]
+%ifdef CLD_NEEDED
 	cld
+%endif
+;%if g_rgwEepromTypeToSizeInWords = 0	; *FIXME* It really is but NASM won't accept this.
+	mov		cx, [cs:bx]
+;%else
+;	mov		cx, [cs:bx+g_rgwEepromTypeToSizeInWords]
+;%endif
 	rep movsw
 
Index: /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Flash.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Flash.asm	(revision 591)
+++ /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Flash.asm	(revision 592)
@@ -78,5 +78,7 @@
 ALIGN JUMP_ALIGN
 Flash_SinglePageWithFlashvarsInSSBP:
+%ifdef CLD_NEEDED
 	cld
+%endif
 	call	AreSourceAndDestinationPagesEqualFromFlashvarsInSSBP
 	je		SHORT .NoNeedToFlashThePage	; CF cleared
@@ -305,53 +307,21 @@
 ALIGN JUMP_ALIGN
 WaitUntilEepromPageWriteHasCompleted:
-	call	.InitializeTimeoutCounterForEepromPollingWithFlashvarsInSSBP
-	mov		es, [bp+FLASHVARS.fpNextDestinationPage+2]
-	mov		di, [bp+FLASHVARS.wLastOffsetWritten]
-ALIGN JUMP_ALIGN
-.PollEeprom:
-	call	.HasWriteCycleCompleted
-	je		SHORT .PageWriteCompleted	; CF cleared
-	call	TimerTicks_GetTimeoutTicksLeftToAXfromDSBX
-	jnc		SHORT .PollEeprom
-ALIGN JUMP_ALIGN
-.PageWriteCompleted:
-	ret
-
-;--------------------------------------------------------------------
-; .InitializeTimeoutCounterForEepromPollingWithFlashvarsInSSBP
-;	Parameters:
-;		SS:BP:	Ptr to FLASHVARS
-;	Returns:
-;		DS:BX:	Ptr to timeout counter variable
-;	Corrupts registers:
-;		AX
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-.InitializeTimeoutCounterForEepromPollingWithFlashvarsInSSBP:
 	push	ss
 	pop		ds
 	lea		bx, [bp+FLASHVARS.wTimeoutCounter]
 	mov		ax, EEPROM_POLLING_TIMEOUT_TICKS
-	jmp		TimerTicks_InitializeTimeoutFromAX
-
-;--------------------------------------------------------------------
-; .HasWriteCycleCompleted
-;	Parameters:
-;		ES:DI:	Ptr to last written byte in EEPROM
-;		SS:BP:	Ptr to FLASHVARS
-;	Returns:
-;		ZF:		Set if write cycle has completed
-;				Cleared if write cycle in progress
-;	Corrupts registers:
-;		AX
-;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
-.HasWriteCycleCompleted:
-	mov		ah, [es:di]		; Load byte from EEPROM
-	mov		al, [bp+FLASHVARS.bLastByteWritten]
-	and		ax, 8080h		; Clear all but bit 7 from both bytes
-	cmp		al, ah			; Set ZF if high bits are the same
-	ret
-
+	call	TimerTicks_InitializeTimeoutFromAX
+	mov		es, [bp+FLASHVARS.fpNextDestinationPage+2]
+	mov		di, [bp+FLASHVARS.wLastOffsetWritten]
+ALIGN JUMP_ALIGN
+.PollEeprom:
+	mov		al, [es:di]							; Load byte from EEPROM
+	xor		al, [bp+FLASHVARS.bLastByteWritten]	; Clear SF if the most significant bits are the same
+	jns		SHORT .PageWriteCompleted			; With CF cleared
+	call	TimerTicks_GetTimeoutTicksLeftToAXfromDSBX
+	jnc		SHORT .PollEeprom
+ALIGN JUMP_ALIGN, ret
+.PageWriteCompleted:
+	ret
 
 ;--------------------------------------------------------------------
Index: /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/IdeAutodetect.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/IdeAutodetect.asm	(revision 591)
+++ /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/IdeAutodetect.asm	(revision 592)
@@ -118,6 +118,6 @@
 	; example Promise FloppyMAX has Control Block at STANDARD_CONTROL_BLOCK_OFFSET but Sound Blaster 16 (CT2290)
 	; use DEVICE_ATA_SECONDARY_PORTCTRL for Tertiary and Quaternary even though only Secondary should use that.
-	call	ChangeDifferentControlBlockAddressToSI
-	je		SHORT .RedetectTertiaryOrQuaternaryWithDifferentControlBlockAddress
+	call	ChangeControlBlockAddressInSI
+	jz		SHORT .RedetectTertiaryOrQuaternaryWithDifferentControlBlockAddress
 
 
@@ -130,5 +130,5 @@
 	mov		si, dx
 	add		si, BYTE XTCF_CONTROL_BLOCK_OFFSET
-	shl		bx, 1						; SHL 1 register offsets for XT-CF
+	eSHL_IM	bx, 1						; SHL 1 register offsets for XT-CF
 	call	DetectIdeDeviceFromPortsDXandSIwithOffsetsInBLandBH
 	mov		al, DEVICE_8BIT_XTCF_PIO8
@@ -233,5 +233,5 @@
 
 ;--------------------------------------------------------------------
-; ChangeDifferentControlBlockAddressToSI
+; ChangeControlBlockAddressInSI
 ;	Parameters:
 ;		DX:		IDE Base Port address
@@ -241,7 +241,7 @@
 ;				Cleared if different control block address is not possible
 ;	Corrupts registers:
-;		AH
-;--------------------------------------------------------------------
-ChangeDifferentControlBlockAddressToSI:
+;		Nothing
+;--------------------------------------------------------------------
+ChangeControlBlockAddressInSI:
 	cmp		si, 368h
 	je		SHORT .TrySecondAlternative
@@ -252,6 +252,5 @@
 	je		SHORT .TryLastAlternative
 	cmp		si, 3E0h
-	je		SHORT .TryLastAlternative
-	ret		; Return with ZF cleared
+	jne		SHORT .Return	; With ZF cleared
 
 .TryLastAlternative:
@@ -260,5 +259,6 @@
 .TrySecondAlternative:
 	sub		si, BYTE 8h		; 368h to 360h, 3E8h to 3E0h
-	xor		ah, ah			; Set ZF
+	cmp		sp, sp			; Set ZF
+.Return:
 	ret
 
Index: /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Main.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Main.asm	(revision 591)
+++ /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Main.asm	(revision 592)
@@ -132,5 +132,5 @@
 	call	Buffers_Clear
 	call	EEPROM_FindXtideUniversalBiosROMtoESDI
-	jnc		SHORT .InitializationCompleted
+	jc		SHORT .InitializationCompleted
 	mov		[CFGVARS.wEepromSegment], es
 .InitializationCompleted:
Index: /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/MenuEvents.asm
===================================================================
--- /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/MenuEvents.asm	(revision 591)
+++ /trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/MenuEvents.asm	(revision 592)
@@ -84,7 +84,6 @@
 	pop		ds
 
-	mov		WORD [si+MENUINIT.wItems], ax
-	mov		WORD [si+MENUINIT.bTitleLines], TITLE_LINES_IN_MENU
-	mov		WORD [si+MENUINIT.bInfoLines], INFO_LINES_IN_MENU
+	mov		[si+MENUINIT.wItems], ax
+	mov		WORD [si+MENUINIT.wTitleAndInfoLines], INFO_LINES_IN_MENU << 8 | TITLE_LINES_IN_MENU
 	mov		BYTE [si+MENUINIT.bWidth], MENU_WIDTH
 	CALL_DISPLAY_LIBRARY GetColumnsToALandRowsToAH
@@ -112,5 +111,6 @@
 ALIGN JUMP_ALIGN
 .QuitProgram:
-	call	Dialogs_DisplayQuitDialog
+	mov		bx, g_szDlgExitToDos
+	call	Dialogs_DisplayYesNoResponseDialogWithTitleStringInBX
 	jz		SHORT .ExitToDOS
 	clc
@@ -169,6 +169,7 @@
 ALIGN JUMP_ALIGN
 .RefreshItemFromCX:
-	cmp		cx, NO_ITEM_HIGHLIGHTED
-	je		SHORT .NothingToRefresh
+	inc		cx					; NO_ITEM_HIGHLIGHTED ?
+	jz		SHORT .NothingToRefresh
+	dec		cx
 	call	Menupage_GetActiveMenupageToDSDI
 	call	Menupage_GetCXthVisibleMenuitemToDSSIfromDSDI
@@ -185,6 +186,7 @@
 ALIGN JUMP_ALIGN
 .RefreshInformation:
-	cmp		cx, NO_ITEM_HIGHLIGHTED
-	je		SHORT .NothingToRefresh
+	inc		cx					; NO_ITEM_HIGHLIGHTED ?
+	jz		SHORT .NothingToRefresh
+	dec		cx
 	call	Menupage_GetActiveMenupageToDSDI
 	call	Menupage_GetCXthVisibleMenuitemToDSSIfromDSDI
@@ -213,8 +215,8 @@
 ALIGN JUMP_ALIGN
 .PrintLoadStatus:
-	mov		ax, [g_cfgVars+CFGVARS.wFlags]
-	test	ax, FLG_CFGVARS_FILELOADED
+	mov		al, [g_cfgVars+CFGVARS.wFlags]
+	test	al, FLG_CFGVARS_FILELOADED
 	jnz		SHORT .PrintNameOfLoadedFile
-	test	ax, FLG_CFGVARS_ROMLOADED
+	test	al, FLG_CFGVARS_ROMLOADED
 	mov		si, g_szEEPROM
 	jnz		SHORT .PrintNameOfLoadedFileOrEeprom
@@ -253,5 +255,5 @@
 ALIGN JUMP_ALIGN
 .PrintStatusOfUnsavedChanges:
-	test	WORD [g_cfgVars+CFGVARS.wFlags], FLG_CFGVARS_UNSAVED
+	test	BYTE [g_cfgVars+CFGVARS.wFlags], FLG_CFGVARS_UNSAVED
 	jz		SHORT .ReturnSinceNothingToPrint
 	mov		si, g_szUnsaved
